## org.eclipse.uml2.uml
Interface BehavioralFeature

All Superinterfaces:
  Element, org.eclipse.emf.ecore.EModelElement, org.eclipse.emf.ecore.EObject, Feature, NamedElement, Namespace, org.eclipse.emf.common.notify.Notifier, RedefinableElement

All Known Subinterfaces:
  Operation, Reception

    public interface BehavioralFeature

extends Namespace, Feature

A representation of the model object 'Behavioral Feature'. A behavioral feature is a feature of a classifier that specifies an aspect of the behavior of its instances. A behavioral feature is implemented (realized) by a behavior. A behavioral feature specifies that a classifier will respond to a designated request by invoking its implementing method. A behavioral feature owns zero or more parameter sets.

The following features are supported:

- `Owned Parameter`
- `Is Abstract`
- `Method`
- `Concurrency`
- `Raised Exception`
- `Owned Parameter Set`

See Also:
  `UMLPackage.getBehavioralFeature()`

Method Summary
`Parameter` `createOwnedParameter(java.lang.String name, Type type)` Creates a new `Parameter`, with the specified 'Name', and 'Type', and appends it to the 'Owned Parameter' containment reference list
`ParameterSet` `createOwnedParameterSet(java.lang.String name)` Creates a new `ParameterSet`, with the specified 'Name', and appends it to the 'Owned Parameter Set' containment reference list
`Parameter` `createReturnResult(java.lang.String name, Type type)` Creates a return result parameter with the specified name and type.
`CallConcurrencyKind` `getConcurrency()` Returns the value of the 'Concurrency' attribute.
`Behavior` `getMethod(java.lang.String name)` Retrieves the first `Behavior` with the specified 'Name' from the 'Method' reference list
`Behavior` `getMethod(java.lang.String name, boolean ignoreCase, org.eclipse.emf.ecore.EClass eClass)` Retrieves the first `Behavior` with the specified 'Name' from the 'Method' reference list
`org.eclipse.emf.common.util.EList<Behavior>` `getMethods()` Returns the value of the 'Method' reference list.
`Parameter` `getOwnedParameter(java.lang.String name, Type type)` Retrieves the first `Parameter` with the specified 'Name', and 'Type' from the 'Owned Parameter' containment reference list
`Parameter` `getOwnedParameter(java.lang.String name, Type type, boolean ignoreCase, boolean createOnDemand)` Retrieves the first `Parameter` with the specified 'Name', and 'Type' from the 'Owned Parameter' containment reference list
`org.eclipse.emf.common.util.EList<Parameter>` `getOwnedParameters()` Returns the value of the 'Owned Parameter' containment reference list.
`ParameterSet` `getOwnedParameterSet(java.lang.String name)` Retrieves the first `ParameterSet` with the specified 'Name' from the 'Owned Parameter Set' containment reference list
`ParameterSet` `getOwnedParameterSet(java.lang.String name, boolean ignoreCase, boolean createOnDemand)` Retrieves the first `ParameterSet` with the specified 'Name' from the 'Owned Parameter Set' containment reference list
`org.eclipse.emf.common.util.EList<ParameterSet>` `getOwnedParameterSets()` Returns the value of the 'Owned Parameter Set' containment reference list.
`Type` `getRaisedException(java.lang.String name)` Retrieves the first `Type` with the specified 'Name' from the 'Raised Exception' reference list
`Type` `getRaisedException(java.lang.String name, boolean ignoreCase, org.eclipse.emf.ecore.EClass eClass)` Retrieves the first `Type` with the specified 'Name' from the 'Raised Exception' reference list
`org.eclipse.emf.common.util.EList<Type>` `getRaisedExceptions()` Returns the value of the 'Raised Exception' reference list.
`boolean` `isAbstract()` Returns the value of the 'Is Abstract' attribute.
`void` `setConcurrency(CallConcurrencyKind value)` Sets the value of the '`Concurrency`' attribute
`void` `setIsAbstract(boolean value)` Sets the value of the '`Is Abstract`' attribute

Methods inherited from interface org.eclipse.uml2.uml.Namespace

`createElementImport, createElementImport, createOwnedRule, createOwnedRule, createPackageImport, createPackageImport, excludeCollisions, getElementImport, getElementImport, getElementImports, getImportedElements, getImportedMember, getImportedMember, getImportedMembers, getImportedPackages, getMember, getMember, getMembers, getNamesOfMember, getOwnedMember, getOwnedMember, getOwnedMembers, getOwnedRule, getOwnedRule, getOwnedRules, getPackageImport, getPackageImport, getPackageImports, importMembers, membersAreDistinguishable, validateMembersDistinguishable`

Methods inherited from interface org.eclipse.uml2.uml.Feature
`getFeaturingClassifier, getFeaturingClassifier, getFeaturingClassifiers, isStatic, setIsStatic`

Methods inherited from interface org.eclipse.uml2.uml.RedefinableElement
`getRedefinedElement, getRedefinedElement, getRedefinedElements, getRedefinitionContext, getRedefinitionContext, getRedefinitionContexts, isConsistentWith, isLeaf, isRedefinitionContextValid, setIsLeaf, validateRedefinitionConsistent, validateRedefinitionContextValid`

Method Detail

### getOwnedParameters

    org.eclipse.emf.common.util.EList<Parameter> getOwnedParameters()

  Returns the value of the 'Owned Parameter' containment reference list. The list contents are of type `Parameter`.

  This feature subsets the following features:

  - '`Owned Member`'
  Specifies the ordered set of formal parameters of this BehavioralFeature.

  Returns:
    the value of the 'Owned Parameter' containment reference list.
  See Also:
    `UMLPackage.getBehavioralFeature_OwnedParameter()`

### createOwnedParameter

    Parameter createOwnedParameter(java.lang.String name,
                                   Type type)

  Creates a new `Parameter`, with the specified 'Name', and 'Type', and appends it to the 'Owned Parameter' containment reference list.

  Parameters:
    `name` - The 'Name' for the new `Parameter`, or `null`.
    `type` - The 'Type' for the new `Parameter`, or `null`.
  Returns:
    The new `Parameter`.
  See Also:
    `getOwnedParameters()`

### getOwnedParameter

    Parameter getOwnedParameter(java.lang.String name,
                                Type type)

  Retrieves the first `Parameter` with the specified 'Name', and 'Type' from the 'Owned Parameter' containment reference list.

  Parameters:
    `name` - The 'Name' of the `Parameter` to retrieve, or `null`.
    `type` - The 'Type' of the `Parameter` to retrieve, or `null`.
  Returns:
    The first `Parameter` with the specified 'Name', and 'Type', or `null`.
  See Also:
    `getOwnedParameters()`

### getOwnedParameter

    Parameter getOwnedParameter(java.lang.String name,
                                Type type,
                                boolean ignoreCase,
                                boolean createOnDemand)

  Retrieves the first `Parameter` with the specified 'Name', and 'Type' from the 'Owned Parameter' containment reference list.

  Parameters:
    `name` - The 'Name' of the `Parameter` to retrieve, or `null`.
    `type` - The 'Type' of the `Parameter` to retrieve, or `null`.
    `ignoreCase` - Whether to ignore case in `String` comparisons.
    `createOnDemand` - Whether to create a `Parameter` on demand if not found.
  Returns:
    The first `Parameter` with the specified 'Name', and 'Type', or `null`.
  See Also:
    `getOwnedParameters()`

### isAbstract

    boolean isAbstract()

  Returns the value of the 'Is Abstract' attribute. The default value is `"false"`. If true, then the behavioral feature does not have an implementation, and one must be supplied by a more specific element. If false, the behavioral feature must have an implementation in the classifier or one must be inherited from a more general element.

  Returns:
    the value of the 'Is Abstract' attribute.
  See Also:
    `setIsAbstract(boolean)`, `UMLPackage.getBehavioralFeature_IsAbstract()`

### setIsAbstract

    void setIsAbstract(boolean value)

  Sets the value of the '`Is Abstract`' attribute.

  Parameters:
    `value` - the new value of the 'Is Abstract' attribute.
  See Also:
    `isAbstract()`

### getMethods

    org.eclipse.emf.common.util.EList<Behavior> getMethods()

  Returns the value of the 'Method' reference list. The list contents are of type `Behavior`. It is bidirectional and its opposite is '`Specification`'. A behavioral description that implements the behavioral feature. There may be at most one behavior for a particular pairing of a classifier (as owner of the behavior) and a behavioral feature (as specification of the behavior).

  Returns:
    the value of the 'Method' reference list.
  See Also:
    `UMLPackage.getBehavioralFeature_Method()`, `Behavior.getSpecification()`

### getMethod

    Behavior getMethod(java.lang.String name)

  Retrieves the first `Behavior` with the specified 'Name' from the 'Method' reference list.

  Parameters:
    `name` - The 'Name' of the `Behavior` to retrieve, or `null`.
  Returns:
    The first `Behavior` with the specified 'Name', or `null`.
  See Also:
    `getMethods()`

### getMethod

    Behavior getMethod(java.lang.String name,
                       boolean ignoreCase,
                       org.eclipse.emf.ecore.EClass eClass)

  Retrieves the first `Behavior` with the specified 'Name' from the 'Method' reference list.

  Parameters:
    `name` - The 'Name' of the `Behavior` to retrieve, or `null`.
    `ignoreCase` - Whether to ignore case in `String` comparisons.
    `eClass` - The Ecore class of the `Behavior` to retrieve, or `null`.
  Returns:
    The first `Behavior` with the specified 'Name', or `null`.
  See Also:
    `getMethods()`

### getConcurrency

    CallConcurrencyKind getConcurrency()

  Returns the value of the 'Concurrency' attribute. The default value is `"sequential"`. The literals are from the enumeration `CallConcurrencyKind`. Specifies the semantics of concurrent calls to the same passive instance (i.e., an instance originating from a class with isActive being false). Active instances control access to their own behavioral features.

  Returns:
    the value of the 'Concurrency' attribute.
  See Also:
    `CallConcurrencyKind`, `setConcurrency(CallConcurrencyKind)`, `UMLPackage.getBehavioralFeature_Concurrency()`

### setConcurrency

    void setConcurrency(CallConcurrencyKind value)

  Sets the value of the '`Concurrency`' attribute.

  Parameters:
    `value` - the new value of the 'Concurrency' attribute.
  See Also:
    `CallConcurrencyKind`, `getConcurrency()`

### getRaisedExceptions

    org.eclipse.emf.common.util.EList<Type> getRaisedExceptions()

  Returns the value of the 'Raised Exception' reference list. The list contents are of type `Type`. References the Types representing exceptions that may be raised during an invocation of this feature. The signals that the behavioral feature raises as exceptions.

  Returns:
    the value of the 'Raised Exception' reference list.
  See Also:
    `UMLPackage.getBehavioralFeature_RaisedException()`

### getRaisedException

    Type getRaisedException(java.lang.String name)

  Retrieves the first `Type` with the specified 'Name' from the 'Raised Exception' reference list.

  Parameters:
    `name` - The 'Name' of the `Type` to retrieve, or `null`.
  Returns:
    The first `Type` with the specified 'Name', or `null`.
  See Also:
    `getRaisedExceptions()`

### getRaisedException

    Type getRaisedException(java.lang.String name,
                            boolean ignoreCase,
                            org.eclipse.emf.ecore.EClass eClass)

  Retrieves the first `Type` with the specified 'Name' from the 'Raised Exception' reference list.

  Parameters:
    `name` - The 'Name' of the `Type` to retrieve, or `null`.
    `ignoreCase` - Whether to ignore case in `String` comparisons.
    `eClass` - The Ecore class of the `Type` to retrieve, or `null`.
  Returns:
    The first `Type` with the specified 'Name', or `null`.
  See Also:
    `getRaisedExceptions()`

### getOwnedParameterSets

    org.eclipse.emf.common.util.EList<ParameterSet> getOwnedParameterSets()

  Returns the value of the 'Owned Parameter Set' containment reference list. The list contents are of type `ParameterSet`.

  This feature subsets the following features:

  - '`Owned Member`'
  The ParameterSets owned by this BehavioralFeature.

  Returns:
    the value of the 'Owned Parameter Set' containment reference list.
  See Also:
    `UMLPackage.getBehavioralFeature_OwnedParameterSet()`

### createOwnedParameterSet

    ParameterSet createOwnedParameterSet(java.lang.String name)

  Creates a new `ParameterSet`, with the specified 'Name', and appends it to the 'Owned Parameter Set' containment reference list.

  Parameters:
    `name` - The 'Name' for the new `ParameterSet`, or `null`.
  Returns:
    The new `ParameterSet`.
  See Also:
    `getOwnedParameterSets()`

### getOwnedParameterSet

    ParameterSet getOwnedParameterSet(java.lang.String name)

  Retrieves the first `ParameterSet` with the specified 'Name' from the 'Owned Parameter Set' containment reference list.

  Parameters:
    `name` - The 'Name' of the `ParameterSet` to retrieve, or `null`.
  Returns:
    The first `ParameterSet` with the specified 'Name', or `null`.
  See Also:
    `getOwnedParameterSets()`

### getOwnedParameterSet

    ParameterSet getOwnedParameterSet(java.lang.String name,
                                      boolean ignoreCase,
                                      boolean createOnDemand)

  Retrieves the first `ParameterSet` with the specified 'Name' from the 'Owned Parameter Set' containment reference list.

  Parameters:
    `name` - The 'Name' of the `ParameterSet` to retrieve, or `null`.
    `ignoreCase` - Whether to ignore case in `String` comparisons.
    `createOnDemand` - Whether to create a `ParameterSet` on demand if not found.
  Returns:
    The first `ParameterSet` with the specified 'Name', or `null`.
  See Also:
    `getOwnedParameterSets()`

### createReturnResult

    Parameter createReturnResult(java.lang.String name,
                                 Type type)

  Creates a return result parameter with the specified name and type.

  Parameters:
    `name` - The name for the new return result, or null.
    `type` - The type for the new return result, or null.

Copyright 2003, 2007 IBM Corporation and others. All Rights Reserved.